import * as React from "react";
export declare type BreakpointConfig = {
    readonly [key: string]: number;
};
export declare type CurrentBreakpoint = {
    breakpoint?: string;
    maxWidth?: number;
    minWidth?: number;
};
export declare type CallbackFn = (args: CurrentBreakpoint) => any;
interface Props {
    readonly breakpoints: BreakpointConfig;
    readonly onChange?: CallbackFn;
    readonly children?: React.ReactNode;
    readonly defaultBreakpoint?: string;
}
declare type MediaQuery = {
    breakpoint: string;
    maxWidth?: number;
    minWidth: number;
    query: string;
};
declare type State = {
    current?: CurrentBreakpoint;
    mediaQueries?: MediaQuery[];
};
export default class BreakpointObserver extends React.Component<Props, State> {
    callback?: CallbackFn;
    constructor(props: Props);
    componentDidMount(): void;
    componentDidUpdate(props: Props): void;
    render(): {} | null;
    private createMediaQueries;
    private addMediaQueryListener;
    private updateBreakpoint;
}
export declare const Provider: typeof BreakpointObserver;
export declare const Consumer: React.Consumer<CurrentBreakpoint>;
export declare type WithBreakpointProps = CurrentBreakpoint;
export declare const withBreakpoint: <ComponentProps extends {}>(Component: React.ComponentType<ComponentProps & CurrentBreakpoint>) => (props: ComponentProps) => JSX.Element;
export declare const useBreakpoint: () => CurrentBreakpoint;
export {};
